#!/bin/bash

cd JSBSim
# autogen
./autogen.sh
# configure
/usr/local/src/emsdk_portable/emscripten/incoming/emconfigure ./configure
# make
/usr/local/src/emsdk_portable/emscripten/incoming/emmake make
# compile
/usr/local/src/emsdk_portable/emscripten/incoming/emcc \
src/initialization/FGInitialCondition.o \
src/initialization/FGTrim.o \
src/initialization/FGTrimAxis.o \
src/initialization/FGSimplexTrim.o \
src/initialization/FGTrimmer.o \
src/initialization/FGLinearization.o \
src/models/atmosphere/FGMSIS.o \
src/models/atmosphere/FGMSISData.o \
src/models/atmosphere/FGMars.o \
src/models/atmosphere/FGStandardAtmosphere.o \
src/models/atmosphere/FGWinds.o \
src/models/propulsion/FGElectric.o \
src/models/propulsion/FGEngine.o \
src/models/propulsion/FGForce.o \
src/models/propulsion/FGNozzle.o \
src/models/propulsion/FGPiston.o \
src/models/propulsion/FGPropeller.o \
src/models/propulsion/FGRocket.o \
src/models/propulsion/FGTank.o \
src/models/propulsion/FGThruster.o \
src/models/propulsion/FGTurbine.o \
src/models/propulsion/FGTurboProp.o \
src/models/propulsion/FGTransmission.o \
src/models/propulsion/FGRotor.o \
src/models/flight_control/FGDeadBand.o \
src/models/flight_control/FGFCSComponent.o \
src/models/flight_control/FGFilter.o \
src/models/flight_control/FGGain.o \
src/models/flight_control/FGKinemat.o \
src/models/flight_control/FGSummer.o \
src/models/flight_control/FGSwitch.o \
src/models/flight_control/FGFCSFunction.o \
src/models/flight_control/FGSensor.o \
src/models/flight_control/FGPID.o \
src/models/flight_control/FGActuator.o \
src/models/flight_control/FGAccelerometer.o \
src/models/flight_control/FGGyro.o \
src/models/flight_control/FGMagnetometer.o \
src/models/flight_control/FGWaypoint.o \
src/models/flight_control/FGAngles.o \
src/models/flight_control/FGDistributor.o \
src/models/FGAerodynamics.o \
src/models/FGAircraft.o \
src/models/FGAtmosphere.o \
src/models/FGAuxiliary.o \
src/models/FGFCS.o \
src/models/FGGroundReactions.o \
src/models/FGInertial.o \
src/models/FGLGear.o \
src/models/FGMassBalance.o \
src/models/FGModel.o \
src/models/FGOutput.o \
src/models/FGPropagate.o \
src/models/FGPropulsion.o \
src/models/FGInput.o \
src/models/FGExternalReactions.o \
src/models/FGExternalForce.o \
src/models/FGBuoyantForces.o \
src/models/FGGasCell.o \
src/models/FGAccelerations.o \
src/models/FGSurface.o \
src/input_output/FGGroundCallback.o \
src/input_output/FGPropertyManager.o \
src/input_output/FGScript.o \
src/input_output/FGXMLElement.o \
src/input_output/FGXMLParse.o \
src/input_output/FGfdmSocket.o \
src/input_output/FGOutputType.o \
src/input_output/FGOutputFG.o \
src/input_output/FGOutputSocket.o \
src/input_output/FGOutputFile.o \
src/input_output/FGOutputTextFile.o \
src/input_output/FGPropertyReader.o \
src/input_output/FGModelLoader.o \
src/input_output/FGInputType.o \
src/input_output/FGInputSocket.o \
src/math/FGColumnVector3.o \
src/math/FGFunction.o \
src/math/FGLocation.o \
src/math/FGMatrix33.o \
src/math/FGPropertyValue.o \
src/math/FGQuaternion.o \
src/math/FGRealValue.o \
src/math/FGTable.o \
src/math/FGCondition.o \
src/math/FGRungeKutta.o \
src/math/FGModelFunctions.o \
src/math/FGNelderMead.o \
src/math/FGStateSpace.o \
src/simgear/props/props.o \
src/simgear/xml/xmlparse.o \
src/simgear/xml/xmltok.o \
src/simgear/xml/xmlrole.o \
src/simgear/xml/easyxml.o \
src/simgear/magvar/coremag.o \
src/JSBSim.o \
src/FGFDMExec.o \
src/FGJSBBase.o \
-o ../index.js -I./src \
--memory-init-file 0 \
-O2

cd ..
